package org.eclipse.tptp.chat.servlet;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.Date;
import java.util.Iterator;
import java.util.Vector;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.apache.commons.lang.StringEscapeUtils;
import org.eclipse.tptp.chat.dao.ChatDAO;
import org.eclipse.tptp.chat.data.User;

public class ListUsersInRoomServlet extends HttpServlet {
	
	public void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		this.doPost(request, response);	
	}

	public void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		HttpSession session = request.getSession();
		
	      User user = (User)session.getAttribute("user");
	      user.setLastRequest(new Date());
	      session.setAttribute("user", user);
	      
	      String roomName = (String)request.getSession().getAttribute("roomName");
	      ChatDAO dao = ChatDAO.getInstance();
	      Vector userList = dao.getUserList(roomName);
	      
	      StringBuffer xmlOut = new StringBuffer(1024);
	      xmlOut.append("<users>");
	      for (Iterator it = userList.iterator(); it.hasNext();) {
	        User user1 = (User)it.next();
	        xmlOut.append("<user name=\"" +
	          StringEscapeUtils.escapeXml(user1.getUsername()) + "\"/>");
	      }
	      xmlOut.append("</users>");
	      
	      response.setContentType("text/xml");
	      PrintWriter out = response.getWriter();
	      out.println(xmlOut.toString());
	      out.flush();
	}
}
